
package de.ivu.elect.presentation.niederschrift;

import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.inject.Named;

import de.ivu.elect.business.gebietsbaum.boundary.GebietSelectChangeEvent;
import de.ivu.elect.business.niederschrift.entity.NiederschriftKorrektur;
import de.ivu.elect.jee.faces.PreConditionCheck;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.presentation.hilfe.OnlineHilfeId;
import de.ivu.elect.presentation.security.AbstractGebietSecurityFilter;

@OnlineHilfeId("253")
@Named(AbstractNiederschriftKorrekturSearchView.COMPONENT_NAME)
public class NiederschriftKorrekturSearchView extends AbstractNiederschriftKorrekturSearchView {

  private static final long serialVersionUID = 1L;

  public NiederschriftKorrekturSearchView() {
    super();
  }

  @PreConditionCheck
  public String preConditionCheck() {
    if (isGebietSelected()) {
      return null;
    }

    return getStartViewId();
  }

  @Override
  protected AbstractGebietSecurityFilter<NiederschriftKorrektur> getGebietSecurityFilter() {
    return AbstractGebietSecurityFilter.createEntityMitGebietSecurityFilter(getEinsehenGebietSecurity());
  }

  /**
   * @deprecated To be removed...
   * @see NiederschriftKorrekturSearchView#initSearchParametersByContext
   */
  @Deprecated
  @Override
  public void presetSearchParameters() {
    // To be removed...
  }

  @Override
  protected void initSearchParametersByContext() {
    super.initSearchParametersByContext();

    getSearchParameters().setGebiet(getSelectedGebiet());
    getSearchParameters().setIncludeUntergebiete(true); // ELECT-2209, Niederschriften immer nur auf unterster Gebietsebene --> immer "true"
  }

  public String getGebietNameMitNummer() {
    return getSelectedGebietNameFormatted();
  }

  @Override
  public void addProperties(FormBuilder formBuilder) {
    // nichts zu tun
  }

  public void onGebietSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) GebietSelectChangeEvent event) {
    reset();
  }
}
